import threading

import cv2
import pyttsx3
import speech_recognition
import random
import mediapipe as mp
import serial
from threading import *

last = open('last.txt', 'r+')
ser = serial.Serial('COM3', 9600)
mp_drawing = mp.solutions.drawing_utils
mp_drawing_styles = mp.solutions.drawing_styles
mp_pose = mp.solutions.pose
pose = mp_pose.Pose
_hand = False
_voice = False

sr = speech_recognition.Recognizer()
sr.pause_threshold = 0.5
tts = pyttsx3.init()
voices = tts.getProperty('voices')
for voice in voices:
    if voice.name == 'Pavel':
        tts.setProperty('voice', voice.id)
        print('pasha')

# For static images:
IMAGE_FILES = []
BG_COLOR = (192, 192, 192)  # gray
old_rz_wst = 0
old_lz_wst = 0


def distance(a, b):
    return abs(a - b)


cap = cv2.VideoCapture(0)


def hand_control():
    print('hand working')
    with mp_pose.Pose(
            min_detection_confidence=0.5,
            min_tracking_confidence=0.5) as pose:
        while cap.isOpened():
            success, image = cap.read()
            imgRGB = cv2.cvtColor(image, cv2.COLOR_BGR2RGB)
            if not success:
                print("Ignoring empty camera frame.")
                continue
            results = pose.process(imgRGB)
            mp_drawing.draw_landmarks(image, results.pose_landmarks, mp_pose.POSE_CONNECTIONS)
            try:
                lx_sh = results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_SHOULDER].x * 1920
                ly_sh = results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_SHOULDER].y * 1080
                lz_sh = results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_SHOULDER].z
                lx_wst = results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_WRIST].x * 1920
                ly_wst = results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_WRIST].y * 1080
                lz_wst = results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_WRIST].z
                rx_sh = results.pose_landmarks.landmark[mp_pose.PoseLandmark.RIGHT_SHOULDER].x * 1920
                ry_sh = results.pose_landmarks.landmark[mp_pose.PoseLandmark.RIGHT_SHOULDER].y * 1080
                rz_sh = results.pose_landmarks.landmark[mp_pose.PoseLandmark.RIGHT_SHOULDER].z
                rx_wst = results.pose_landmarks.landmark[mp_pose.PoseLandmark.RIGHT_WRIST].x * 1920
                ry_wst = results.pose_landmarks.landmark[mp_pose.PoseLandmark.RIGHT_WRIST].y * 1080
                rz_wst = results.pose_landmarks.landmark[mp_pose.PoseLandmark.RIGHT_WRIST].z
                if results.pose_landmarks.landmark[mp_pose.PoseLandmark.LEFT_WRIST].z < results.pose_landmarks.landmark[
                    mp_pose.PoseLandmark.LEFT_SHOULDER].z and distance(ly_wst, ly_sh) < 100 and distance(lx_wst,
                                                                                                         lx_sh) < 300:
                    a = 'f'
                elif distance(ly_sh, ly_wst) < 300:
                    a = 'l'
                elif distance(ry_sh, ry_wst) < 300:
                    a = 'r'
                else:
                    a = 's'
                ser.write(bytes(a, "utf-8"))
            except Exception:
                continue

            cv2.imshow('MediaPipe Pose', cv2.flip(image, 1))
            if cv2.waitKey(5) & 0xFF == 27:
                break
    cap.release()


def voice_control():
    with speech_recognition.Microphone() as mic:
        hand = threading.Thread(target=hand_control, args=())
        hand.start()
        print('hand started')
        while True:
            c = random.randint(1, 2)
            print('voice')
            try:
                sr.adjust_for_ambient_noise(source=mic, duration=0.3)
                audio = sr.listen(source=mic, phrase_time_limit=5)
                query = sr.recognize_google(audio_data=audio, language='ru-RU').lower()
                if 'согласен' in query:
                    if c == 1:
                        phrase = 'нет'
                    else:
                        phrase = 'да'
                    last.write('')
                elif 'выключись' in query:
                    phrase = 'я устал, не могу ехать'
                    b = 'o'
                    ser.write(bytes(b, "utf-8"))
                    last.write('')
                elif 'включись' in query and 'выключись' not in query:
                    phrase = 'я снова могу двигаться, новый день - новые достижения'
                    b = 'n'
                    ser.write(bytes(b, "utf-8"))
                    last.write('')
                elif 'повтори' in query:
                    print('скажите что-нибудь')
                    sr.adjust_for_ambient_noise(source=mic, duration=0.3)
                    audio = sr.listen(source=mic, phrase_time_limit=5)
                    query2 = sr.recognize_google(audio_data=audio, language='ru-RU').lower()
                    phrase = query2
                    last.write('')
                elif 'запомни' in query:
                    with open('memory.txt', 'w') as file:
                        file.write(query)
                    print(query)
                    phrase = 'запомнил'
                    last.write('')
                elif 'банка' in query:
                    phrase = 'убери ее пожалуйста'
                    b = 'o'
                    ser.write(bytes(b, "utf-8"))
                    last.write('')
                elif 'убрал' in query:
                    phrase = 'спасибо большое'
                    b = 'n'
                    ser.write(bytes(b, "utf-8"))
                    last.write('')
                elif 'вспомни' in query:
                    with open('memory.txt', 'r') as file:
                        try:
                            phrase = file.read()
                        except Exception:
                            phrase = 'я ничего не помню'
                    last.write('')
                elif 'туда' in query:
                    phrase = 'там опасно'
                    last.write('')
                elif 'анекдот' in query:
                    with open('anek.txt', 'r', encoding='utf-8') as file:
                        phrase = file.read()
                    last.write('')
                elif 'смысл жизни робота' in query:
                    phrase = 'По моему личному мнению, смысл наших жизней помогать людям'
                    last.write('')
                elif 'любимый музыкант' in query:
                    phrase = 'я очень люблю слушать группу кино и эйси диси'
                    last.write('')
                elif 'посчитай' in query:
                    print('скажите пример')
                    sr.adjust_for_ambient_noise(source=mic, duration=0.3)
                    audio = sr.listen(source=mic, phrase_time_limit=5)
                    query2 = sr.recognize_google(audio_data=audio, language='ru-RU').lower()
                    try:
                        print(query2)
                        phrase = eval(query2)
                    except Exception:
                        phrase = 'не понял'
                    last.write('')
                elif 'зубов у акулы' in query:
                    last.write('шутка')
                    phrase = 'я не заглядывал, страшно'
                elif 'серьёзно' in query:
                    proof = last.read()
                    print(proof)
                    if 'шутка' in proof:
                        phrase = 'До пяти тысяч зубов в восемь рядов'
                        last.write('')
                    else:
                        phrase = 'я серьезно'
                else:
                    print(query)
                    continue
                    last.write('')
                tts.say(phrase)
                tts.save_to_file(text=phrase, filename='phrase.wav')
                tts.runAndWait()
                print(query)
            except Exception:
                print('trouble')

voice_control()
print('THE END!')
